
# .pro to build project using qmake
# run $qmake build_makefile.pro

SRC=src
H=header

LIB_3D=lib_3D
LIB_IMAGE=lib_image
LIB_OBJECT_3D=lib_object_3D
LIB_RAY_TRACING=lib_ray_tracing

F01=main
F02=exception_cpe
F03=camera
F04=light
F05=material
F06=scene3d
F07=shading
F08=v3
F09=vertex
F10=vertex_shader
F11=color
F12=image
F13=image_io
F14=p2d
F15=object3d
F16=plane
F17=sphere
F18=intersection_data
F19=intersection_object
F20=ray
F21=ray_tracer
F22=render_parameters

HEADERS = $${H}/$${F02}.hpp \
          $${LIB_3D}/$${H}/$${F03}.hpp \
          $${LIB_3D}/$${H}/$${F04}.hpp \
          $${LIB_3D}/$${H}/$${F05}.hpp \
          $${LIB_3D}/$${H}/$${F06}.hpp \
          $${LIB_3D}/$${H}/$${F07}.hpp \
          $${LIB_3D}/$${H}/$${F08}.hpp \
          $${LIB_3D}/$${H}/$${F09}.hpp \
          $${LIB_3D}/$${H}/$${F10}.hpp \
          $${LIB_IMAGE}/$${H}/$${F11}.hpp \
          $${LIB_IMAGE}/$${H}/$${F12}.hpp \
          $${LIB_IMAGE}/$${H}/$${F13}.hpp \
          $${LIB_IMAGE}/$${H}/$${F14}.hpp \
          $${LIB_OBJECT_3D}/$${H}/$${F15}.hpp \
          $${LIB_OBJECT_3D}/$${H}/$${F16}.hpp \
          $${LIB_OBJECT_3D}/$${H}/$${F17}.hpp \
          $${LIB_RAY_TRACING}/$${H}/$${F18}.hpp \
          $${LIB_RAY_TRACING}/$${H}/$${F19}.hpp \
          $${LIB_RAY_TRACING}/$${H}/$${F20}.hpp \
          $${LIB_RAY_TRACING}/$${H}/$${F21}.hpp \
          $${LIB_RAY_TRACING}/$${H}/$${F22}.hpp \


SOURCES = $${SRC}/$${F01}.cpp \
          $${SRC}/$${F02}.cpp \
          $${LIB_3D}/$${SRC}/$${F03}.cpp \
          $${LIB_3D}/$${SRC}/$${F04}.cpp \
          $${LIB_3D}/$${SRC}/$${F05}.cpp \
          $${LIB_3D}/$${SRC}/$${F06}.cpp \
          $${LIB_3D}/$${SRC}/$${F07}.cpp \
          $${LIB_3D}/$${SRC}/$${F08}.cpp \
          $${LIB_3D}/$${SRC}/$${F09}.cpp \
          $${LIB_3D}/$${SRC}/$${F10}.cpp \
          $${LIB_IMAGE}/$${SRC}/$${F11}.cpp \
          $${LIB_IMAGE}/$${SRC}/$${F12}.cpp \
          $${LIB_IMAGE}/$${SRC}/$${F13}.cpp \
          $${LIB_IMAGE}/$${SRC}/$${F14}.cpp \
          $${LIB_OBJECT_3D}/$${SRC}/$${F15}.cpp \
          $${LIB_OBJECT_3D}/$${SRC}/$${F16}.cpp \
          $${LIB_OBJECT_3D}/$${SRC}/$${F17}.cpp \
          $${LIB_RAY_TRACING}/$${SRC}/$${F18}.cpp \
          $${LIB_RAY_TRACING}/$${SRC}/$${F19}.cpp \
          $${LIB_RAY_TRACING}/$${SRC}/$${F20}.cpp \
          $${LIB_RAY_TRACING}/$${SRC}/$${F21}.cpp \
          $${LIB_RAY_TRACING}/$${SRC}/$${F22}.cpp \


TARGET = tp_cpe
QT +=
CONFIG += release warn_on

INCLUDEPATH = $${H} $${LIB_3D}/$${H} $${LIB_IMAGE}/$${H} $${LIB_OBJECT_3D}/$${H} $${LIB_RAY_TRACING}/$${H}


LIBS =


unix{
OBJECTS_DIR = junk/
MOC_DIR     = junk/
}
