/*
**    TP 4ETI CPE Lyon
**    Copyright (C) 2012 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef VERTEX_HPP
#define VERTEX_HPP

#include <v3.hpp>
#include <color.hpp>

namespace cpe
{
/** \brief Container for a vertex (position+normal+color) */
struct vertex
{

        /** \brief direct constructor */
        vertex(const v3& coordinate=v3(),const v3& normal=v3(0,0,1),const color& c=color(255,0,0));

        /** \brief 3D position */
        v3 p;
        /** \brief normal at this position */
        v3 n;
        /** \brief color at this position */
        color c;
};
}
#endif
