/*
**    TP 4ETI CPE Lyon
**    Copyright (C) 2012 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef VERTEX_SHADER_HPP
#define VERTEX_SHADER_HPP



namespace cpe
{

struct vertex;
struct shading;
struct light;
struct camera;
class color;

/** \brief Helper class that compute the color of a vertex given a normal, shading and light parameters */
class vertex_shader
{
    public:

        /** \brief compute the color associated to the current vertex */
        static color compute_color(const vertex& v,const shading& shading_param,const light& light_param,const camera& camera_param);


    private:
};
}
#endif
