/*
**    TP 4ETI CPE Lyon
**    Copyright (C) 2012 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef OBJECT3D_HPP
#define OBJECT3D_HPP

#include <v3.hpp>

#include <vector>


namespace cpe
{
    class ray;
    struct intersection_data;



    /** \brief Generic container of a shape with intersect method */
    class object3d
    {
    public:

        // ********************************************* //
        // ********************************************* //
        //  CONSTRUCTOR
        // ********************************************* //
        // ********************************************* //

        /** \brief empty constructor */
        object3d(){}
        /** \brief destructor */
        virtual ~object3d(){}


        // ********************************************* //
        // ********************************************* //
        //  INTERSECTION
        // ********************************************* //
        // ********************************************* //

        /** \brief Method to call on a generic object to get intersection with a ray */
        virtual std::vector<intersection_data> intersect(const ray& seg) const = 0;

    private:
    };




}

#endif
