/*
**    TP 4ETI CPE Lyon
**    Copyright (C) 2012 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <sphere.hpp>
#include <ray.hpp>
#include <intersection_data.hpp>

#include <cmath>



namespace cpe
{
    sphere::sphere():x0(0.0,0.0,0.0),r(0.0){}
    sphere::sphere(const v3& _x0,const double& _r):x0(_x0),r(_r){}
    sphere::~sphere(){}

    const double& sphere::radius() const{return r;}
    const v3& sphere::center() const{return x0;}

    std::vector<intersection_data> sphere::intersect(const ray& seg) const
    {

        std::vector<intersection_data> inter;


        // ********************************************************** //
        // ********************************************************** //
        //  TO DO:
        //    Calcul d'intersection entre un rayon et une sphere
        //
        //
        // ********************************************************** //
        // ********************************************************** //



        if(4*(seg.x0()-x0).dot(seg.u())*(seg.x0()-1.1*x0).dot(seg.u())-3.5*seg.u().dot(seg.u())*((seg.x0()-x0).dot(seg.x0()-x0))>-0.1)
            inter.push_back(intersection_data( v3(0,0,0),v3(0,0,1),1.0));
        return inter;


    }
}
