/*
**    TP 4ETI CPE Lyon
**    Copyright (C) 2012 Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef INTERSECTION_DATA_HPP
#define INTERSECTION_DATA_HPP

#include <v3.hpp>

namespace cpe
{

/** \brief container for intersection data (position, normal, and relative position with respect to the ray) */
struct intersection_data
{
        /** \brief direct constructor */
        intersection_data(const v3& x=v3(),const v3& n=v3(0,0,1),const double& t=-1.0);

        /** \brief position at the intersection */
        v3 x;
        /** \brief normal at the intersection */
        v3 n;
        /** \brief relative position of the intersection along the ray */
        double t;

};
}

#endif
